<template>
  <div class="app-container">
    <!--筛选条件-->
    <div class="search-div">
      <div class="search-left">
        <el-form ref="selectForm" :inline="true" :model="listQuery" class="form-container">
          <el-row>
            <el-form-item class="selectForm-container-item">
              <el-input v-model.trim="listQuery.strategyName" placeholder="策略名称" clearable/>
            </el-form-item>
            <el-button class="filter-item" type="primary" icon="el-icon-search" @click="search">搜索</el-button>
            <el-button class="filter-item" type="primary" icon="el-icon-edit" @click="editthreshold">阈值设置</el-button>
            <el-button class="filter-item" type="primary" icon="el-icon-edit" @click="edittime">采集设置</el-button>
          </el-row>
        </el-form>
      </div>
      <div class="clearfloat"/>
    </div>
    <!--查询结果Table显示-->
    <div>
      <el-row class="table-title">
        <el-col :span="6"><div class="title-header"><i class="el-icon-menu"/>数据列表</div>
        </el-col>
        <el-col :span="12" :offset="6" class="edit_btns">
          <el-button class="edit_btn" size="small" @click="del">删除</el-button>
          <el-button class="edit_btn" size="small" @click="check">下发</el-button>
          <el-button class="edit_btn" size="small" @click="add">新增</el-button>
        </el-col>
      </el-row>
      <el-table v-loading="listLoading" :data="list" class="table" border @selection-change="handleSelectionChange">
        <el-table-column align="center" type="selection" width="55"/>
        <el-table-column :index="indexMethod" label="#" align="center" type="index" />
        <el-table-column v-for="column in columns" :key="column.value" :label="column.text" :width="column.width" :align="column.align" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row[column.value] }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="120">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click="edit(scope.row)">编辑</el-button>
            <el-button type="text" size="small" @click="detail(scope.row)">详情</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <!--分页-->
    <div class="pagination-container">
      <el-pagination
        v-show="total>listQuery.limit"
        :current-page="listQuery.offset"
        :page-sizes="[20,30,50]"
        :page-size="listQuery.limit"
        :total="total"
        align="center"
        layout="total, sizes, prev, pager, next"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"/>
    </div>
    <edit-strategy v-show="dialogFormVisible" ref="editstrategy" @watchChild="fetchData"/>
    <edit-threshold v-show="dialogFormVisible1" ref="editthreshold"/>
    <edit-time v-show="dialogFormVisible2" ref="edittime"/>
  </div>
</template>

<script>
import { getStrategyList, batchDelete, batchIssue } from '@/api/system/strategy'
import EditStrategy from './components/editStrategy'
import EditThreshold from './components/editThreshold'
import EditTime from './components/editTime'

export default {
  name: 'ListStrategy',
  components: { EditThreshold, EditStrategy, EditTime },
  data() {
    return {
      listQuery: {
        strategyName: '',
        offset: 1,
        limit: 20,
        sort: '',
        order: ''
      }, // 筛选条件
      columns: [
        {
          text: '策略名称',
          value: 'strategyName',
          align: 'center'
        },
        {
          text: '关联设备类型',
          value: 'deviceTypeName',
          align: 'center'
        },
        {
          text: '生效日期',
          value: 'startDate',
          align: 'center'
        },
        {
          text: '失效日期',
          value: 'endDate',
          align: 'center'
        },
        {
          text: '优先级',
          value: 'priorityName',
          align: 'center'
        },
        {
          text: '创建时间',
          value: 'createTime',
          align: 'center'
        },
        {
          text: '创建用户',
          value: 'createUserName',
          align: 'center'
        }
      ],
      total: 0, // 数据总数
      list: [], // 报警列表
      listLoading: true, // 列表加载
      multipleSelection: [], // 多选选中项
      dialogFormVisible: false,
      dialogFormVisible1: false,
      dialogFormVisible2: false
    }
  },
  created() {
    this.fetchData()// 获取数据
  },
  activated() {
    this.fetchData()
  },
  methods: {
    // 多选触发方法
    handleSelectionChange(val) {
      this.multipleSelection = val
    },
    // 检查选择情况
    checkSelection() {
      if (this.multipleSelection.length === 0) {
        return false
      } else {
        return true
      }
    },
    check() {
      if (this.checkSelection()) {
        const devIds = []
        this.multipleSelection.forEach(function(value, index) {
          devIds.push(value.id)
        })
        this.$confirm(
          '确定要下发所选策略吗？',
          '确认操作',
          {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }
        ).then(() => {
          batchIssue(devIds).then(response => {
            if (response.code === 200) {
              this.$message.success('下发成功')
              this.fetchData()
            }
          })
        })
      } else {
        this.$message.error('至少选中一项')
      }
    },
    del() {
      if (this.checkSelection()) {
        const devIds = []
        this.multipleSelection.forEach(function(value, index) {
          devIds.push(value.id)
        })
        this.$confirm(
          '确定要删除所选策略吗？',
          '确认操作',
          {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }
        ).then(() => {
          batchDelete(devIds).then(response => {
            if (response.code === 200) {
              this.$message.success('删除成功')
              this.fetchData()
            }
          })
        })
      } else {
        this.$message.error('至少选中一项')
      }
    },
    fetchData(isNowPage = true) {
      this.listLoading = true
      if (!isNowPage) { // 是否显示当前页，否则跳转第一页
        this.listQuery.offset = 1
      }
      getStrategyList(this.listQuery).then(response => {
        if (response.code === 200) {
          this.list = response.data.rows
          this.total = parseInt(response.data.total)
        } else {
          this.$message.error(response.message)
        }
        this.listLoading = false
      })
    },
    // 查询数据
    search() {
      this.fetchData(false)
    },
    detail(row) {
      this.dialogFormVisible = true
      this.$refs.editstrategy.initDialog('detail', this.dialogFormVisible, row)
    },
    edit(row) {
      this.dialogFormVisible = true
      this.$refs.editstrategy.initDialog('update', this.dialogFormVisible, row)
    },
    add(row) {
      this.dialogFormVisible = true
      this.$refs.editstrategy.initDialog('create', this.dialogFormVisible, row)
    },
    editthreshold() {
      this.dialogFormVisible1 = true
      this.$refs.editthreshold.initDialog('update', this.dialogFormVisible1, null)
    },
    edittime() {
      this.dialogFormVisible2 = true
      this.$refs.edittime.initDialog('update', this.dialogFormVisible2, null)
    },
    // 序号计算
    indexMethod(index) {
      return this.listQuery.limit * (this.listQuery.offset - 1) + index + 1
    },
    // 改变页容量
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.fetchData()
    },
    // 改变当前页
    handleCurrentChange(val) {
      this.listQuery.offset = val
      this.fetchData()
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  $tableTitleHeight:46px;
  .app-container{
    margin-bottom:20px
  }
  .table{
    margin-bottom: 20px;
  }
  .small-row-class{
    height: 15px;
  }
  .pagination-container{
    margin-bottom: 50px;
  }
  .table-title{
    background-color:rgba(243, 243, 243, 1);
    height: $tableTitleHeight;
    .title-header{
      line-height:$tableTitleHeight;
      color: #606266;
      font-size: 15px;
      i{
        margin-left: 5px;
        margin-right: 5px;
      }
    }
  }
  .edit_btns{
    .edit_btn{
      float:right;
      margin:7px 3px;//为了需要居中显示margin-top和bottom要用$tableTitleHeight减去按钮原高度除以2
    }
  }
</style>
<style rel="stylesheet/scss" lang="scss">
  .small-row-class td{
    padding:2px 0px;
  }
</style>
